unit Bangs;

interface
Uses
  Boxes,
  BoxApi,
  Types,
  Windows;


Procedure RegisterBangs;
Procedure UnRegisterBangs;

implementation

Function AddBangCommand(command: string; f: Pointer): Boolean; cdecl; external lsapidll;
Function RemoveBangCommand(command: string): Boolean; cdecl; external lsapidll;

Function GetBoxFromName(BoxName: String): PBox;
Var
  Box: PBox;
Begin
  Box := First_Box;
  BoxName := UpStr(GetToken(BoxName,1));
  While ( Box<>nil )AND( UpStr(Box^.title)<>BoxName ) Do
    Box := Box^.Next_Box;
 GetBoxFromName := Box;
End;

Procedure LsBox_create(Caller:Integer;Args:pchar); cdecl;
Begin
  BuildBox(GetToken(Args,1),GetToken(Args,2));
End;

Procedure LsBox_Destroy(Caller:Integer;Args:pchar); cdecl;
Var
  Box,PrevBox: PBox;

  Function FindPrevBox(Box:Pointer):Pointer;
  Var
    PrevBox: PBox;
  Begin
    PrevBox := First_Box;
    While ((PrevBox<>nil)AND(PrevBox^.Next_Box<>Box))Do
      PrevBox := PrevBox^.Next_Box;
    FindPrevBox := PrevBox;
  End;

Begin
 Box := GetBoxFromName(Args);
 If (Box <> nil) then
   Begin
     DestroyBox(Box);
     If Box=First_Box then
       First_Box := Box^.Next_Box
       Else
       Begin
         PrevBox := FindPrevBox(Box);
         PrevBox^.Next_Box := Box^.Next_Box;
       End;
     Dispose (Box);
   End
End;

Procedure LsBox_Show(Caller:Integer;Args:pchar); cdecl;
Var
  Box: PBox;
Begin
  Box := GetBoxFromName(Args);
  If (Box <> nil) then
   Begin
    ShowWindow(Box^.hMainWnd,SW_Show);
    SetFlag(Box^.Flags,Hidden,false);
   End;
End;

Procedure LsBox_Hide(Caller:Integer;Args:pchar); cdecl;
Var
  Box: PBox;
Begin
  Box := GetBoxFromName(Args);
  If (Box <> nil) then
   Begin
    ShowWindow(Box^.hMainWnd,SW_Hide);
    SetFlag(Box^.Flags,Hidden,true);
   End;
End;

Procedure LsBox_Toggle(Caller:Integer;Args:pchar); cdecl;
Var
  Box: PBox;
Begin
  Box := GetBoxFromName(Args);
  If (Box <> nil) then
    If GetFlag(Box^.Flags,Hidden) then
      LsBox_show(Caller,Args)
    Else
      LsBox_hide(Caller,Args)
End;

Procedure LsBox_ResetPos(Caller:Integer;Args:pchar); cdecl;
Var
  Box: PBox;
Begin
  Box := First_Box;
  While ( Box<>nil ) Do
  Begin
    SetWindowPos(Box^.hMainWnd, 0, Box^.xPos, Box^.yPos, 0, 0, SWP_NOSIZE+SWP_NOZORDER);
    Box := Box^.Next_Box;
  End;
End;


Procedure RegisterBangs;
Begin
  AddBangCommand('!LsBoxCreate',@LsBox_create);
  AddBangCommand('!LsBoxDestroy',@LsBox_Destroy);
  AddBangCommand('!LsBoxHide',@LsBox_Hide);
  AddBangCommand('!LsBoxShow',@LsBox_Show);
  AddBangCommand('!LsBoxToggle',@LsBox_Toggle);
  AddBangCommand('!LsBoxResetPos',@LsBox_ResetPos);
End;

Procedure UnRegisterBangs;
Begin
  RemoveBangCommand('!LsBoxCreate');
  RemoveBangCommand('!LsBoxDestroy');
  RemoveBangCommand('!LsBoxHide');
  RemoveBangCommand('!LsBoxShow');
  RemoveBangCommand('!LsBoxToggle');
  RemoveBangCommand('!LsBoxResetPos');
End;


end.
