unit Shortcuts;

// Version 1.1
// Removed MergeRgn
// Removed not needed code from SetWindowRgnEx
// Made DestroyShortcuts recursive
// Version 1.0

Interface
Uses
  Windows,
  BoxFiles,
  BoxAPI,
  Types;

Procedure BuildShortcuts(Box:PBox);
Procedure DestroyShortcuts(Shortcut: PShortcut);

Implementation

Function GetShortcutFromClientWnd(Wnd: Integer): Pointer;
Var
  Box : PBox;

  Function Rek(Shortcut: PShortcut; Wnd: Integer): Pointer;
  Begin
    If (Shortcut^.Next_Shortcut = nil) OR (Shortcut^.SWnd = Wnd) then
      Result := Shortcut
    Else
      Result := Rek(Shortcut^.Next_Shortcut, Wnd);
  End;

Begin
  Box := GetBoxFromWnd(First_Box, GetParent(Wnd));
  Result := Rek(Box^.First_ShortCut, Wnd);
end;

Function ClientWndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Shortcut: PShortcut;
  Event: TTrackMouseEvent;
  TempRgn: HRGN;
Begin
  ClientWndProc := 0;
  Shortcut := GetShortcutFromClientWnd(Wnd);
  Case Msg Of
    WM_ERASEBKGND:
      BitBlt(wParam,0,0,ShortCut^.Width,ShortCut^.Height,ShortCut^.Dc_0,0,0,SRCCOPY);
    WM_MOUSEMOVE:
     With Shortcut^ do
       If State=Normal Then
        Begin
          Dc_0 := Dc_2;
          State := Over;
          SetWindowRgnEx(Swnd,Rgn_2);
          SetWindowPos(fBox^.hMainWnd, 0, 0, 0, fBox^.Width, fBox^.Height, SWP_NOZORDER+SWP_NOMOVE);
          InvalidateRect(SWnd,nil,True);
          Event.cbSize := Sizeof(TTrackMouseEvent);
          Event.dwFlags := TME_LEAVE;
          Event.hwndTrack := Wnd;
          _TrackMouseEvent(Event);
        End;
    WM_MOUSELEAVE:
     With Shortcut^ do
      Begin
        Dc_0 := Dc_1;
        State := Normal;
        SetWindowPos(fBox^.hMainWnd, 0, 0, 0, fBox^.Width, fBox^.Height, SWP_NOZORDER+SWP_NOMOVE);
        SetWindowRgnEx(Swnd,Rgn_1);
        InvalidateRect(SWnd,nil,True);
      End;
  WM_LBUTTONDOWN:
   With Shortcut^ do
     Begin
       Dc_0 := Dc_3;
       State := Click;
       SetWindowPos(fBox^.hMainWnd, 0, 0, 0, fBox^.Width, fBox^.Height, SWP_NOZORDER+SWP_NOMOVE);
       SetWindowRgnEx(Swnd,Rgn_3);
       InvalidateRect(SWnd,nil,True);
     End;
  WM_LBUTTONUP:
   With Shortcut^ do
     If State=Click Then
       Begin
          Dc_0 := Dc_2;
          State := Over;
          SetWindowRgnEx(Swnd,Rgn_2);
          SetWindowPos(fBox^.hMainWnd, 0, 0, 0, fBox^.Width, fBox^.Height, SWP_NOZORDER+SWP_NOMOVE);
          InvalidateRect(SWnd,nil,True);
          //Execute Stuff
            PostMessage(Command_HWND,BM_COMMAND,0,Integer(PChar(Shortcut^.Command)));
       End;
    Else
      ClientWndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

Procedure BuildShortcuts(Box:PBox);
Var
  wc: TWndClass;
  Bitmap_1, Bitmap_2,
  Bitmap_3: HBitmap;
  Buffer, Hint: String;
  ShortCut: PShortcut;
  MainDC: HDC;
  TempRgn: HRGN;
Begin
  //Box^.First_Shortcut := nil;

  Buffer := BoxReadNextConfig(Box^.BoxPtr,'*Shortcut');
  While ( Buffer<>'' ) Do
    Begin
      New(ShortCut);
      Shortcut^.Next_Shortcut := Box^.First_Shortcut;
      Box^.First_Shortcut := Shortcut;

      With ShortCut^ Do
      Begin
        fBox := Box;
        Hint := GetToken(Buffer,1);
        xPos := Str2Int(GetToken(Buffer,2));
        yPos := Str2Int(GetToken(Buffer,3));
        Command := CommandToken(Buffer,7);
        If Command[1]='#' then
        Begin
        
        End;
      End;
      //Build Shortcut Class
      If NOT GetClassInfo(Inst,'LsBoxShortcut',wc) then
      Begin
        FillChar(wc,sizeof(wc), #0);
        wc.lpfnWndProc := @ClientWndProc;
        wc.lpszClassName := 'LsBoxShortcut';
        wc.hInstance := Inst;
        RegisterClassA(wc);
      End;

      With Shortcut^ do
      Begin
        SWnd := CreateWindowExA(
        0,'LsBoxShortcut',nil,WS_CHILD,
        0,0,0,0,Box^.hMainWnd,0,
        Inst,nil);

        MainDC := GetDC(SWnd);

        Bitmap_1 := LoadLSImage(PChar(GetToken(Buffer,4)),nil);
        If ( Bitmap_1=0 ) then
          Messagebox(0,'Check Box File: Can''t load image',nil,0)
        Else
          Begin
            Rgn_1 := BitmapToRegion(Bitmap_1,RGB(255,0,255),$101010,0,0);
            DC_1 := CreateCompatibleDC(MainDC);
            SelectObject(DC_1, Bitmap_1);
            GetLSBitmapSize(Bitmap_1,Width,Height);
            DeleteObject(Bitmap_1);
          End;

        Bitmap_2 := LoadLSImage(PChar(GetToken(Buffer,5)),nil);
        If ( Bitmap_2=0 ) then
          Begin
            DC_2 := DC_1;
            RGN_2 := RGN_1
          End Else
          Begin
            Rgn_2 := BitmapToRegion(Bitmap_2,RGB(255,0,255),$101010,0,0);
            DC_2 := CreateCompatibleDC(MainDC);
            SelectObject(DC_2, Bitmap_2);
            DeleteObject(Bitmap_2);
          End;

        Bitmap_3 := LoadLSImage(PChar(GetToken(Buffer,6)),nil);
        If ( Bitmap_3=0 ) then
          Begin
            DC_3 := DC_1;
            RGN_3 := RGN_1
          End Else
          Begin
            Rgn_3 := BitmapToRegion(Bitmap_3,RGB(255,0,255),$101010,0,0);
            DC_3 := CreateCompatibleDC(MainDC);
            SelectObject(DC_3, Bitmap_3);
            DeleteObject(Bitmap_3);
          End;

        ReleaseDC(Swnd,MainDC);

        DC_0 := DC_1;
        RGN_0 := RGN_1;

        SetWindowRgnEx(SWnd,Rgn_0);

        SetWindowPos(SWnd,HWND_BOTTOM,xPos,yPos,Width,Height,SWP_SHOWWINDOW);
        CreateHint(Swnd,PChar(Hint));

        State := Normal;
      End;

      Buffer := BoxReadNextConfig(Box^.BoxPtr,'*Shortcut');
    End;

End;

Procedure DestroyShortcuts(Shortcut: PShortcut);
Begin
 If ( Shortcut<>nil ) then
  With Shortcut^ Do
  Begin
    RemoveHint(SWnd);
    If ( Rgn_3<>Rgn_1 ) then
      DeleteObject(Rgn_3);
    If ( Rgn_2<>Rgn_1 ) then
      DeleteObject(Rgn_2);
    If ( Rgn_1<>0 ) then
      DeleteObject(Rgn_1);
    If ( DC_3<>DC_1 ) then
      DeleteDC(DC_3);
    If ( DC_2<>DC_1 ) then
      DeleteDC(DC_2);
    If ( DC_1<>0 ) then
      DeleteDC(DC_1);
    DestroyWindow(SWnd);
    DestroyShortcuts (Next_Shortcut);
    Dispose (Shortcut);
  end;
End;


Begin

End.